#!/usr/bin/env python
# File created on 2015/12/16
#!coding:utf-8
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

import sys
from optparse import OptionParser

def MakeOption():
    #make option 
	parser=OptionParser(usage="%prog [-h] [-v] -d[--protein_taxondb=] -b[--blast_result=] -s[--similarity=] -o[--output=]\n\nDescription:\n \
This script is designed for protein sequence taxonomy annotation\n\nInformation:\n\
author: Li, Chaonan\n\
copyright: Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n", version="%prog 1.0")
	parser.add_option("-d", "--protein_taxondb", action="store", dest="protein_taxdb",  
                      help="protein sequence taxonomy database with txt format", 
                      default=False)
	parser.add_option("-b", "--blast_result", action="store", dest="protein_blast",  
                      help="blast result file with txt format", 
                      default=False)
	parser.add_option("-s", "--similarity", action="store", dest="sims",
                      help="similarity value that you want to set",
                      default=False)
	parser.add_option("-o", "--output", action="store", dest="outputfilename",
                      help="output file name",
                      default=False)
	(options, args) = parser.parse_args()
	#extract option from command line
	database=options.protein_taxdb
	blast_result=options.protein_blast
	similarity=options.sims
	output=open(options.outputfilename,"w")
	
	return(database,blast_result,similarity,output)

def Assigment(d,b,s,o):
	database=d
	blast_result=b
	similarity=s
	output=o
	#create a hash table to save proetin sequence database
	#column one is protein gi number; column two is taxonomy information of protein sequence
	taxon_db={}
	for eachline in open(database):
		eachline_list=eachline.strip("\n").split("\t")
		db_gi=eachline_list[0].strip()
		db_taxon=eachline_list[1].strip()
		taxon_db[db_gi]=db_taxon

	#assign reads or sequence
	#program will query taxonomy information in hash table accoroding 
	#to protein gi numbers
	a=0
	b=0
	c=0
	for eachlines in open(blast_result):
		eachlines_list=eachlines.strip("\n").split("\t")
		query_id=eachlines_list[0]
		identity=eachlines_list[1]
		subject_gi=eachlines_list[2]
		if taxon_db.has_key(subject_gi.strip()):
			taxon=taxon_db[subject_gi.strip()]
			if float(identity)>=float(similarity):
				output.write("%s\t%s\n"%(query_id,taxon))
				a+=1
			else:
				taxon_1="unclassified"
				output.write("%s\t%s\n"%(query_id,taxon_1))
				b+=1
		else:
			taxon_1="unclassified"
			output.write("%s\t%s\n"%(query_id,taxon_1))
			c+=1
	output.close()
	d=b+c
	print "assigned:%s"%a
	print "can not assign:%s"%d
	print "over!good luck!"

def main():
	files=MakeOption()
	DB=files[0]
	BL=files[1]
	SI=files[2]
	OU=files[3]
	Assigment(DB,BL,SI,OU)
	

if __name__ == "__main__":
	main() 
