#!/usr/bin/env python
# File created on 2016/4/6
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

from optparse import OptionParser
import os
def MakeOption():
	parser=OptionParser(usage="%prog [-h] [-v] -p[--path=]\n\nDescription:\n \
This script is designed to check chameras sequences. Before run this program, users must be sure that current PC or WorkStation\
has been installed Usearch (version >=8). Meanwhile, Linux or UNIX OS is necessary and input data cannot be combined.\n\n\
INFORMATION:\n\
Author: Li, Chaonan\n\
Copyright: Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n", version="%prog 1.0")
	parser.add_option("-p", "--path", action="store", dest="paths",  
                      help="The path of sequence file; ALL SAMPLES SHOULD BE SAVED AS SINGLE FILE!\
					  For example:/home/student/licn_pmoA_gongga_seqs/assamble/single_sample/qual_contrl/m.lib/usearch_chimeras_check/", 
                      default=False)
	(options, args) = parser.parse_args()
	file_path=options.paths
	return file_path

# in this function we used linux command lines, So the operating system must be LINUX or UNIX (including MAC OS)
def Chimeras_check(pths):#here pths is the path that save sequence data on users's computer
	filepath=pths
	filename_list=os.listdir(filepath)
	a=1
	b=1
	c=1
	d=1
	for each in filename_list:
		each_file_input=each.strip()
		if each_file_input.endswith(".fasta"):
			nonchimeras=filepath+"nonchimeras/"
			chimeras=filepath+"chimeras/"
			unique_reads=filepath+"unique/"
			sizeout_fasta="unique"+str(c)+".fasta"
			each_ch_output="ch"+str(a)+".fasta"
			each_good_output="good"+str(b)+".fasta"
			a+=1
			b+=1
			c+=1
			if os.path.isdir(nonchimeras):
				pass
			else:
				os.mkdir(nonchimeras)
			if os.path.isdir(chimeras):
				pass
			else:
				os.mkdir(chimeras)
			if os.path.isdir(unique_reads):
				pass
			else:
				os.mkdir(unique_reads)
			os.environ["input_fasta"]=filepath+each_file_input
			os.environ["unique_fasta"]=unique_reads+sizeout_fasta
			os.environ["chimeras_fasta"]=chimeras+each_ch_output
			os.environ["nonchimeras_fasta"]=nonchimeras+each_good_output
			print "NO. %s file: %s...   size annotations is processing..."%(d,each_file_input)
			os.system("usearch8 -derep_prefix $input_fasta -fastaout $unique_fasta -sizeout")
			print "NO. %s file: %s...   chimeras checking and removing..."%(d,each_file_input)
			os.system("usearch8 -uchime_denovo $unique_fasta -chimeras $chimeras_fasta -nonchimeras $nonchimeras_fasta")
			d+=1
		else:
			pass

			
def main():
	ps=MakeOption()#ps is the path users inputted
	Chimeras_check(ps)

if __name__ == "__main__":
	main()
	