#!/usr/bin/env python
# File created on 2016/4/6
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

from optparse import OptionParser
import os
import shutil
def MakeOption():
    parser=OptionParser(usage="%prog [-h] [-v] -p[--path=] -n[--Min_num]\n\nDescription:\n \
This script is desinged to filter sequence file in which sequence numbers less than threshold users set.\
USERS SHOULD NOT COMBINE SEQUENCE FILES!\n\n\
INFORMATION:\n\
Author: Li, Chaonan\n\
Copyright: Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n", version="%prog 1.0")
    parser.add_option("-i", "--inputDir", action="store", dest="inputdir",  
                      help="The input directory saving no-frame-shift sequence files such as './nonchimeras/'", 
                      default=False)
    parser.add_option("-o", "--outputDir", action="store", dest="outputdir",  
                      help="The output directory saving no-frame-shift sequence files such as './nonchimeras/cleaned_sample/'", 
                      default=False)
    parser.add_option("-n", "--Min_num", action="store", dest="min_num",  
                      help="The minimum sequence counts of each sample", 
                      default=False)
    (options, args) = parser.parse_args()
    indir=options.inputdir
    outdir=options.outputdir
    num=options.min_num
    return(indir,outdir,num)

#list all of files of given dir
#this function will return a list saving filenames
def Filter(i,o,n):
    filepath=o
    path=i
    a=0
    b=0
    filename_list=os.listdir(path)
    for each in filename_list:
      each=path+each
      #calculate the records numbers of file
      count=0
      file_handle=open(each,"r")
      while True:
        buffer=file_handle.read(8192*1024)
        if not buffer:
          break
        else:
          count+=buffer.count(">")
      file_handle.close()
      if count>=int(n.strip()):
        if os.path.isdir(filepath):
          pass
        else:
          os.mkdir(filepath)
        shutil.copy(each,filepath)
        a+=1
      else:
        b+=1 
        print "Filename:%s"%each 
    print "Sample that sequence records more than 3000: %s"%a
    print "Sample that sequence records less than 3000: %s"%b
    print "DONE!"
def main():
    files=MakeOption()
    inputpath=files[0]
    outputpath=files[1]
    nums=file[2]
    Filter(inputpath,outputpath,nums)
if __name__ == "__main__":
    main() 
