#!/usr/bin/env python
# File created on 2015/12/16
#!coding:utf-8
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

import os
import sys
from optparse import OptionParser  

def main():
	#make option 
	parser=OptionParser(usage="%prog [-h] [-v] -i[--input=] -o[--output=] -a[--assign=] -n[--singleton=]\n\nDescription:\n \
This script is designed to make otu table using protein sequences\n\nInformation:\n\
author: Li, Chaonan\n\
copyright: Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n\
Files information:\n", version="%prog 1.0")  

	parser.add_option("-i", "--input", action="store", dest="inputfilename",  
                      help="otu file that derived from uclust and pick_otu.py", 
                      default=False)  
	parser.add_option("-o", "--output", action="store", dest="outputfilename",
                      help="otu table file with txt format",
                      default=False) 		 
	parser.add_option("-a", "--assign", action="store", dest="assign_taxon",
                      help="taxonomy assigned file with txt format, which derives from assign_taxonomy_prot.py",
                      default=False) 
	parser.add_option("-n", "--singleton", action="store", dest="sing",
                      help="the singleton otu",
                      default=False)					  
	(options, args) = parser.parse_args() 
    #extract option from command line
	otus=options.inputfilename#read the otu file with text format
	assign_tax=options.assign_taxon#read assigned file with text format
	n=options.sing#the min otu number in all sample
	otu_table=open(options.outputfilename,"w")#create a new file to save the otu table. it is a text file
	#calculate the counts of samples
	#we must pick the col 2 and load into a list
	sample_list=[]
	os.environ["otus"]=otus
	os.system("cat $otus | awk ' { print $2 }' > sample_info.txt")
	for eachline in open("sample_info.txt","r"):
		eachline=eachline.strip("\n").split("_")
		sample_id=eachline[0]
		if sample_id in sample_list:
			pass
		else:
			sample_list.append(sample_id)
	sample_list=sorted(sample_list)
	del sample_list[0]
	#print sample_list


	# make otu table
	# format table header
	otu_id="#OTU ID"
	tax_sig="taxonomy"
	otu_table.write("%s\t"%otu_id)
	for each_sample in sorted(sample_list):
		otu_table.write("%s\t"%each_sample)
	otu_table.write("%s\n"%tax_sig)

	# create a dictionary to save rep_seq id and taxinfo
	rep_id_taxinfo_dict={}
	for eachLine in open(assign_tax,"r"):
		eachLine=eachLine.strip("\n").split("\t")
		rep_id=eachLine[0]
		taxinfo=eachLine[1]
		rep_id_taxinfo_dict[rep_id.strip()]=taxinfo.strip()

	# ***********************************
	a=0
	for eachlines in open(otus,"r"):
		if not eachlines.strip():
			pass
		else:
			list_len=len(eachlines.strip("\n").strip().split("\t"))
			if list_len<=int(n): # trim singleton seq###changed
				pass###changed
			else:
				sam_id_list=[] #add sample id into this list
				sam_id_count_dict={} #add sample id(keys) and sample ids counts(values) into this dictionary
				eachlines=eachlines.strip("\n").split("\t") #return a list
				#print eachlines
				OTU_id=eachlines[0] #pick otu id which exist in col one
				rep_otu=eachlines[1] # pick rep seq id which exist in col two
				#print rep_otu
				for each_id in eachlines[1:]: #parse each elements in list
					each_id=each_id.strip().split("_")#return a list
					samples=each_id[0]
					sam_id_list.append(samples)
            
				for eachs in sorted(sample_list):
					counts=sam_id_list.count(eachs)
					sam_id_count_dict[eachs.strip()]=str(counts)#calculate the counts of each sample 
				otu_table.write("%s\t"%OTU_id)#write the otu id into file
            
				for each_Sample in sorted(sample_list):
					each_Sample=each_Sample.strip()
					values=sam_id_count_dict[each_Sample]
					otu_table.write("%s\t"%values)
				taxonomy=rep_id_taxinfo_dict[rep_otu.strip()]
					# because of our data derives from blast program, here we using rep otu to identify the taxonomy name
				otu_table.write("%s\n"%taxonomy)
				a+=1
				print "...writing NO. %s records..."%a
	print "otu number:%s"%a
	print "over,good luck!"
if __name__ == "__main__":
    main() 
     
            


    
    



