#!/usr/bin/env python
# File created on 2015/12/16
#!coding:utf-8
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

import re
import sys
from optparse import OptionParser 

def MakeOption():
  #make option 
  parser=OptionParser(usage="%prog [-h] [-v] -i[--input=] -o[--output=]\n\nDescription:\n \
This script is designed to pick protein sequence otus from uclust result. The input file should\
be .clstr format\n\nInformation:\n\
author: Li, Chaonan\n\
copyright: Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n\
Files information:\n\
input file: the uclust result file with .clstr format\n\
output file: the out file with txt format\
", version="%prog 1.0")
  parser.add_option("-i", "--input", action="store", dest="inputfilename",
                      help="the uclust result file with .clstr format",
                      default=False)
  parser.add_option("-o", "--output", action="store", dest="outputfilename",
                      help="the out file with txt format",
                      default=False)
  (options, args) = parser.parse_args()
  #extract option from command line
  inputfiles=options.inputfilename
  outputfiles=options.outputfilename
  inputfile=inputfiles
  outputfile=open(outputfiles,"w")
  return (inputfile,outputfile)
def Pick_otu(i,o):
  inputfile=i
  outputfile=o
  #caclulate cluster numbers
  files=open(inputfile,"r")
  count=0
  while True:
    buffer=files.read(8192*1024)
    if not buffer:
      break
    count+=buffer.count(">")
  files.close()

  #parse cluster file
  otu_id=0
  for eachline in open(inputfile,"r"):
    if eachline.startswith(">"):
      outputfile.write("\n")
      outputfile.write("%s\t"%otu_id)
      otu_id+=1
    else:
      patt=".*>(.*)\.\.\..*"
      otu=re.findall(patt,eachline)[0]
      outputfile.write("%s\t"%otu)
  outputfile.close()

  otu_number=otu_id

  print 
  print "OTU number: %s"%otu_number
  print "over, good luck!"

def main():
  files=MakeOption()
  INPUT=files[0]
  OUTPUT=files[1]
  Pick_otu(INPUT,OUTPUT)

if __name__ == "__main__":
    main()


            
        
        
        
        