#!/usr/bin/env python
# File created on 2015/12/16
#!coding:utf-8
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

from Bio import SeqIO
import sys
from optparse import OptionParser 

def MakeOption():
#make option 
	parser=OptionParser(usage="%prog [-h] [-v] -i[--input=] -o[--output=] -f[--ref=]\n\nDescription:\n \
This script is designed to pick represent otu sequences from out file\n\nInformation:\n\
author: Li, Chaonan\n\
copyright: Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n\
Files information:\n\
input file: the protein sequences otus file with txt format; the resampled protein sequences file\
with fasta fomat\n\
output file: the represent protein sequences(according to represent otu read ids)\
", version="%prog 1.0")  

	parser.add_option("-i", "--input", action="store", dest="inputfilename",  
                      help="the protein sequences otus file with txt format", 
                      default=False)  
	parser.add_option("-o", "--output", action="store", dest="outputfilename",
                      help="the represent protein sequences(according to represent otu read ids) file with fasta format",
                      default=False)     
	parser.add_option("-f", "--ref", action="store", dest="reference",
                      help="the resampled protein sequences file with fasta fomat",
                      default=False)      
	(options, args) = parser.parse_args() 
#extract option from command line
	otu_file=options.inputfilename#read the parameter of input file and transfer to a var in main script
	#this is a bad var name because 'otu_file' represent the input filename, that is, the OTU file with text format
	reads=options.reference#read the reference sequences file which produced by resample and header clean with a python script 
	rep=open(options.outputfilename,"w")# read the output filename, creating a new file to save the rep sequences and transfering
	#to a handle named 'rep'
def Pick_rep_seq(i,f,o)
#calculate the file size,that is your rep otu number, but please note that our otu file contains
	otu_file=i
	reads=f
	rep=o
	count = 0  
	thefile = open(otu_file,"r")   
	while True:  
		buffer = thefile.read(1024 * 8192)  
		if not buffer:  
			break  
		count += buffer.count('\n')  
	thefile.close() 
	print "The fasta file contains %s lines..."%count

#pick the otu id and search the rep seq of this otu id
	find_otu_number=0
	for eachline in open(otu_file,"r"):
		if not eachline.strip():#trim the blank line
			pass
		else:
			eachlines=eachline.strip()
			eachline_list=eachline.strip("\n").split("\t")#return a list
			rep_id=eachline_list[1]# extract the id 
			for each_record in SeqIO.parse(reads,"fasta"):
				otu_id=each_record.id.strip()
				otu_seq=each_record.seq.strip()
				if rep_id.strip()==otu_id:
					rep.write(">%s\n%s\n"%(otu_id,otu_seq))
					find_otu_number+=1
					print "...finding NO. %s / %s represent sequences...\nOTU id: %s  \nSequence: %s"%(find_otu_number,count,otu_id,otu_seq)
					break
				else:
					pass
			continue
#calculate the finding otu and filed matching otu
	total_otu=count
	matched_otu=find_otu_number
	failed_matching_otu=count-find_otu_number
	print "Total OTU Number: %s"%count
	print "Finded OTU Number: %s"%matched_otu
	print "Non-Matching OTU Number: %s"%failed_mathcing_otu
	print "///////////////////////////////////////////////"
	print "I AM SO TIRED....OVER! GOOD LUCK!-------BY HEKING..."
	print "//////////////////////////////////////////////"
	
def main():
	files=MakeOption()
	INPUT=files[0]
	REF=files[1]
	OUTPUT=files[2]
	Pick_rep_seq(INPUT,REF,OUTPUT)

if __name__ == "__main__":
	main()
