#!/usr/bin/env python
# File created on 2015/12/16
#!coding:utf-8
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.0"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

import re
import sys
from optparse import OptionParser

def main():
    #make option 
	parser=OptionParser(usage="%prog [-h] [-v] -i[--input=] -o[--output=]\n\nDescription:\n \
This script is designed to parse blast result file. To run this program, the blast outformat must\
be xmlformat(-outfmt 7 in blastp)\n\nInformation:\n\
author: Li, Chaonan\n\
copyright: Copyright 2015, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n", version="%prog 1.0")
	parser.add_option("-i", "--input", action="store", dest="inputfilename",  
                      help="the blastp result file with xml format", 
                      default=False)  
	parser.add_option("-o", "--output", action="store", dest="outputfilename",
                      help="the txt file that save your reads id(query id) and subject ids, as well as identify percentage",
                      default=False)
	(options, args) = parser.parse_args()
	#extract option from command line
	inputfile=options.inputfilename
	outputfile=open(options.outputfilename,"w")
	#read blastp results
	subject_gi_list=[]
	identify_list=[]
	for eachline in open(inputfile): 
		eachline=eachline.strip("\n")
		if "BLASTP 2.2.28+" in eachline:
			if len(subject_gi_list) or len(identify_list):
				print identify_list
				outputfile.write("%s\t"%identify_list[0]) #identify
				outputfile.write("%s\n"%subject_gi_list[0])# take first one as our result
            
			else:
				pass
			subject_gi_list=[]
			identify_list=[]
		else:
        
			if "Query" in eachline:
				patt=".*Query:(.*).*"
				query_id=re.findall(patt,eachline)[0]
				outputfile.write("%s\t"%query_id)
			elif "Database" in eachline:
				pass
			elif "Fields" in eachline:
				pass
			elif "hits" in eachline:
				pass
			else:
				eachline_list=eachline.split("\t") #return a list
				print eachline_list
				excep_str="processed"
				if excep_str in eachline_list[0]:
					pass
				else:
					subject=eachline_list[1]
					smis=eachline_list[2]

					identify_list.append(smis)
					subject_list=subject.split("|") #return a list
					subject_gi=subject_list[1]
					subject_gi_list.append(subject_gi) 
					
					
	outputfile.write("%s\t"%identify_list[0]) #identify
	outputfile.write("%s\n"%subject_gi_list[0])# take first one as our result
	outputfile.close()
	print "over, good luck!"
if __name__ == "__main__":
    main()        
                       
                
    
    
    
    
    
    
    

    