#!/usr/bin/env python
# File created on 2016/4/6
__author__ = "Li,Chaonan"
__copyright__ = "Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences"
__license__ = "GPL"
__version__ = "1.1"
__maintainer__ = "Li,Xiangzhen Group"
__email__ = "chaonanl@yahoo.com"

from optparse import OptionParser

def MakeOption():
	parser=OptionParser(usage="%prog [-h] [-v] -i[--input=] -d[--protein_id=] -o[--output=]\n\nDescription:\n \
This script is designed to create species assignment database according to species assignment provied by Marc in 2013.\n\n\
INFORMATION:\n\
Author: Li, Chaonan\n\
Copyright: Copyright 2016, Li,Xiangzhen Group, CIB, Chinese Academy of Sciences\n\n", version="%prog 1.1")
	parser.add_option("-i", "--input", action="store", dest="inputfile",  
                      help="The species assignment database privieded by Marc et al in 2013; It is must be tab-seperated file [input file]", 
                      default=False)
	parser.add_option("-d", "--protein_ids", action="store", dest="proteinID",  
                      help="The accession number of DNA and GI number of protein sequences returnd from Genbank with tab-seperated format [input file]", 
                      default=False)
	parser.add_option("-o", "--output", action="store", dest="outputfile",  
                      help="The outputfile saving taxa information with amino acid GI numbers as ids of each taxon; It must be tab-seperated text format [output file]", 
                      default=False)
	(options, args) = parser.parse_args()
	inputs=options.inputfile
	prot_id=options.proteinID
	outputs=open(options.outputfile,"w")
	return (inputs,prot_id,outputs)

# create the species assignment database
def DB_create(input_file,prot_id,output_file):
	out_put=output_file
	hash_table={}
	for eachline in open(prot_id):
		eachline_list=eachline.strip("\n").split("\t")
		nucl_ac=eachline_list[0]
		protein_gi=eachline_list[1]
		if hash_table.has_key(nucl_ac):
			pass
		else:
			hash_table[nucl_ac]=protein_gi

	#convert taxon info id
	hash_len=len(hash_table)
	a=0
	b=0
	for each in open(input_file):
		each_list=each.strip("\n").split("\t")
		ids=each_list[0].strip()
		taxon=each_list[1].strip()
		if hash_table.has_key(ids):
			a+=1
			new_id=hash_table[ids]
			out_put.write("%s\t%s\n"%(new_id,taxon))
			print "...converted %s records..."%a
		else:
			b+=1
	out_put.close()
	print "total of protein seq database reocords:%s"%hash_len
	print "matched: %s"%a
	print "can not match: %s"%b

def main():
	file=MakeOption()
	INPUT=file[0]
	ID=file[1]
	OUTPUT=file[2]
	DB_create(INPUT,id,OUTPUT)

if __name__ == "__main__":
	main()
